<HTML>
<HEAD>
<!-- This HTML file has been created by texi2html 1.54
     from lic.texi on 28 April 1999 -->

<TITLE>The Linear Inequality Calculator - Finding Direction Vectors</TITLE>
<link href="lic_12.html" rel=Next>
<link href="lic_10.html" rel=Previous>
<link href="lic_toc.html" rel=ToC>

</HEAD>
<BODY>
<p>Go to the <A HREF="lic_1.html">first</A>, <A HREF="lic_10.html">previous</A>, <A HREF="lic_12.html">next</A>, <A HREF="lic_21.html">last</A> section, <A HREF="lic_toc.html">table of contents</A>.
<P><HR><P>


<H3><A NAME="SEC11" HREF="lic_toc.html#TOC11">Finding Direction Vectors</A></H3>


<PRE>
for i = 1 to N
   for j = i to N
      A[i] = A[j]
</PRE>

<P>
<A NAME="IDX127"></A>

</P>
<P>
For the two accesses of the above loop nest, the following <CODE>LIC</CODE>
script will find the set of direction vectors.  The systems <SAMP>`iterr'</SAMP>
and <SAMP>`iterw'</SAMP> represents the read and write iteration space and the
system <SAMP>`access'</SAMP> is the relationship between the read and the write
access. The entire system is given by intersecting the above three
systems (<SAMP>`full'</SAMP>).  For each possible direction vector, a system
representing that vector is created.  If that vector is valid, the
system will have a solution (<SAMP>`intsol()'</SAMP> is 1).

</P>
<P>
<A NAME="IDX128"></A>
<A NAME="IDX129"></A>
<A NAME="IDX130"></A>
<A NAME="IDX131"></A>
<A NAME="IDX132"></A>
<A NAME="IDX133"></A>
<A NAME="IDX134"></A>
<A NAME="IDX135"></A>

</P>


<PRE>
iterr = [ 1 &#60;= ir &#60;= N 
          ir &#60;= jr &#60;= N ]

iterw = [ 1 &#60;= iw &#60;= N 
          iw &#60;= jw &#60;= N ]

access = [ iw  = jr ]

full = { iterr, iterw, access }

// [= =]
#level3 = { full 
           [ ir = iw
             jr = jw ] }
intsol(level3)

// [= +]
#level2a = { full 
           [ ir = iw
             jr &#62; jw ] }
intsol(level2a)

// [= +]
#level2b = { full 
           [ ir = iw
             jr &#60; jw ] }
intsol(level2b)

// [+ *]
#level1a = { full 
           [ ir &#62; iw ] }
intsol(level1a)

// [+ *]
#level1b = { full 
           [ ir &#60; iw ] }
intsol(level1b)

end
</PRE>

<P>
<A NAME="IDX136"></A>

</P>
<P>
The printout of the example session:

</P>

<PRE>
csh&#62; lic -c
Rapid Prototyping System for Code Generation
&#62; &#60; example2
iterr = [ 1 &#60;= ir &#60;= N
          ir &#60;= jr &#60;= N ]
N-jr &#62;= 0
jr-ir &#62;= 0
N-ir &#62;= 0
-1+ir &#62;= 0

iterw = [ 1 &#60;= iw &#60;= N
          iw &#60;= jw &#60;= N ]
N-jw &#62;= 0
jw-iw &#62;= 0
N-iw &#62;= 0
-1+iw &#62;= 0

access = [ iw  = jr ]
iw-jr &#62;= 0
-iw+jr &#62;= 0

full = { iterr, iterw, access }
N-jr &#62;= 0
jr-ir &#62;= 0
N-ir &#62;= 0
-1+ir &#62;= 0
N-jw &#62;= 0
jw-iw &#62;= 0
N-iw &#62;= 0
-1+iw &#62;= 0
-jr+iw &#62;= 0
jr-iw &#62;= 0

// [= =]
#level3 = { full
           [ ir = iw
             jr = jw ] }
intsol(level3)
1

// [= +]
#level2a = { full
           [ ir = iw
             jr &#62; jw ] }
intsol(level2a)
0

// [= +]
#level2b = { full
           [ ir = iw
             jr &#60; jw ] }
intsol(level2b)
1

// [+ *]
#level1a = { full
           [ ir &#62; iw ] }
intsol(level1a)
0

// [+ *]
#level1b = { full
           [ ir &#60; iw ] }
intsol(level1b)
1

end
 &#62; quit
done(0)

csh&#62;
</PRE>

<P>
<A NAME="IDX137"></A>

</P>
<P>
Thus the set of direction vectors consist of <CODE>[+ *]</CODE>, <CODE>[= +]</CODE>
and <CODE>[= =]</CODE>.

</P>

<P><HR><P>
<p>Go to the <A HREF="lic_1.html">first</A>, <A HREF="lic_10.html">previous</A>, <A HREF="lic_12.html">next</A>, <A HREF="lic_21.html">last</A> section, <A HREF="lic_toc.html">table of contents</A>.
</BODY>
</HTML>
